VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000080&
   BorderStyle     =   0  'Kein
   Caption         =   "Clipping-Beispiel"
   ClientHeight    =   4080
   ClientLeft      =   975
   ClientTop       =   135
   ClientWidth     =   6525
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   72
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'ZReihenfolge
   ScaleHeight     =   295.652
   ScaleMode       =   0  'Benutzerdefiniert
   ScaleWidth      =   183.158
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command1 
      Caption         =   "Ende"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4080
      TabIndex        =   0
      Top             =   3480
      Width           =   1095
   End
   Begin VB.Image Image2 
      Height          =   1740
      Left            =   0
      Top             =   0
      Width           =   6420
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

'Autor: Markus Zeichner
'E-Mail: kosti-@t-online.de

'Dieses Beispielprogramm zeigt wie man mit Hilfe von Path's den
'sichtbaren Fensterbereich manipulieren kann.
'
'Zur Begin werden einige Koordinaten-Arraus definiert anhand
'denen dann Polygone in ein Path gezeichnet werden, danach wird
'der Path in eine Region umgewandelt und schliesslich wird diese
'Region dem Fenster zugewissen.
'
'Wie man anhand des Beispiels sehen kann ist mit Hilfe des
'Path's die Fensterregion nicht auf eliptisch bzw. rechteckig
'begrentzt.
'
'Zwischen BeginPath und EndPath knnen alle Primitiven GDI-
'Zeichenroutinen (wie z.B Polygon, Text, Bezierkurven stehen so
'das kreatives Arbeiten mglich ist.

Option Explicit

Private Declare Function BeginPath Lib "gdi32" (ByVal hdc As _
        Long) As Long
        
Private Declare Function EndPath Lib "gdi32" (ByVal hdc As _
        Long) As Long
        
Private Declare Function SetWindowRgn Lib "user32" (ByVal _
        hwnd As Long, ByVal hrgn As Long, ByVal bredraw As _
        Boolean) As Long
        
Private Declare Function PathToRegion Lib "gdi32" (ByVal hdc _
        As Long) As Long
        
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As _
        Long, ByVal nBkMode As Long) As Long
        
Private Declare Function Polygon Lib "gdi32" (ByVal hdc As _
        Long, lpPoint As Pointapi, ByVal nCount As Long) _
        As Long

Private Type Pointapi
    x As Long
    y As Long
End Type

Private Const RGN_AND As Long = 1&
Private Const RGN_OR As Long = 2&
Private Const RGN_XOR As Long = 3&
Private Const RGN_DIFF As Long = 4&
Private Const RGN_COPY As Long = 5&

Private Sub Form_Load()
    Dim Punkte() As Pointapi
    Dim Punkt() As Pointapi
    Dim Pkt() As Pointapi
    Dim hD As Long
    
    ReDim Punkte(7)
    ReDim Punkt(4)
    ReDim Pkt(4)
    
    Image2.Picture = LoadPicture(App.Path & _
        IIf(Right(App.Path, 1) = "\", "", "\") & "\Pic.gif")
    
    Punkte(0).x = 0
    Punkte(0).y = 120
    Punkte(1).x = 200
    Punkte(1).y = 0
    Punkte(2).x = 400
    Punkte(2).y = 120
    Punkte(3).x = 360
    Punkte(3).y = 120
    Punkte(4).x = 360
    Punkte(4).y = 300
    Punkte(5).x = 40
    Punkte(5).y = 400
    Punkte(6).x = 40
    Punkte(6).y = 120
    Punkte(7).x = 0
    Punkte(7).y = 120
    
    Punkt(0).x = 150
    Punkt(0).y = 300
    Punkt(1).x = 150
    Punkt(1).y = 200
    Punkt(2).x = 250
    Punkt(2).y = 200
    Punkt(3).x = 250
    Punkt(3).y = 300
    Punkt(4).x = 150
    Punkt(4).y = 300
    
    Pkt(0).x = 70
    Pkt(0).y = 150
    Pkt(1).x = 120
    Pkt(1).y = 150
    Pkt(2).x = 120
    Pkt(2).y = 200
    Pkt(3).x = 70
    Pkt(3).y = 200
    Pkt(4).x = 70
    Pkt(4).y = 150
    
    Call BeginPath(hdc)
    Call Polygon(hdc, Punkte(0), UBound(Punkte) + 1)
    Call SetBkMode(hdc, RGN_XOR)
    Call Polygon(hdc, Punkt(0), UBound(Punkt) + 1)
    Call Polygon(hdc, Pkt(0), UBound(Pkt) + 1)
    Call EndPath(hdc)
    
    hD = PathToRegion(hdc)
    Call SetWindowRgn(Me.hwnd, hD, True)
End Sub

Private Sub Command1_Click()
    Unload Me
End Sub

